"""Games, or Adversarial Search. (Chapter 5)
"""

from Utile.utils import *
import time
import random
from IPython.core.display import SVG
from IPython.core.display import display
from IPython.display import clear_output
#from Games.AlphaBetaPlayer import ABplayer
#from Games.Players import RandomPlayer #, QueryPlayer
import random
import time



def play_game(game, players, todisplay=False):
	"""Play an n-person, move-alternating game.
	>>> play_game(Fig52Game(), alphabeta_player, alphabeta_player)
	3
	"""
	
	random.seed(time.time())
	#game.raz()
	state = game.initial
	if todisplay:
		game.display(state)
	i=1
	while True and (i<2000):
		i +=1
		for player in players:
			if game.terminal_test(state):
				return game.utility(state, game.to_move(game.initial))
			move = player.best_move(game, state)
			state = game.result(state, move)
			game.set_state(state)
			game.set_move(move)
			if todisplay:
				game.display(state)
			if game.terminal_test(state):	
				return game.utility(state, game.to_move(game.initial))

#______________________________________________________________________________
# Some Sample Games

class Game:
	"""A game is similar to a problem, but it has a utility for each
	state and a terminal test instead of a path cost and a goal
	test. To create a game, subclass this class and implement actions,
	result, utility, and terminal_test. You may override display and
	successors or you can inherit their default methods. You will also
	need to set the .initial attribute to the initial state; this can
	be done in the constructor."""

	def actions(self, state):
		"Return a list of the allowable moves at this point."
		abstract

	def result(self, state, move):
		"Return the state that results from making a move from a state."
		abstract

	def utility(self, state, player):
		"Return the value of this final state to player."
		abstract

	def terminal_test(self, state):
		"Return True if this is a final state for the game."
		return not self.actions(state)

	def to_move(self, state):
		"Return the player whose move it is in this state."
		return state.to_move

	def display(self, state):
		"Print or otherwise display the state."
		print state

	def __repr__(self):
		return '<%s>' % self.__class__.__name__
   
